source/apps/crawl_space/urls.py
"""Crawl space url routes.

Each of these url patterns is built off a project URL-

    /project/<project_slug>

-and belongs to the "crawl_space" namespace. See `base.urls` for an
explanation of the dynamic route generation.

URLs
----

project/<project_slug>/
    add_crawl/
    add_crawl_model/
    crawls/
    crawls/<crawl_slug/

"""

from django.conf.urls import patterns, url

from apps.crawl_space import views

urlpatterns = patterns('',
    url(r'^add_crawl/$', views.AddCrawlView.as_view(),
        name='add_crawl'),
    url(r'^add_crawl_model/$', views.AddCrawlModelView.as_view(),
        name='add_crawl_model'),
    url(r'^(?P<model_slug>[\w-]+)/delete/$', views.DeleteCrawlModelView.as_view(),
        name='delete_crawl_model'),
    url(r'^crawls/$', views.ListCrawlsView.as_view(),
        name='crawls'),
    url(r'^crawls/(?P<crawl_slug>[\w-]+)/$', views.CrawlView.as_view(),
        name='crawl'),
    url(r'^crawls/(?P<crawl_slug>[\w-]+)/settings/$', views.CrawlSettingsView.as_view(),
        name='crawl_settings'),
    url(r'^crawls/(?P<crawl_slug>[\w-]+)/settings/delete/$', views.DeleteCrawlView.as_view(),
        name='delete_crawl'),
)

source/base/urls.py
"""Base url routes.

This module also dynamically adds url routes to applications present in
INSTALLED_APPS; see the comments below.

URLs
----

/
about/
add_project/
project/

"""

from django.conf.urls import patterns, include, url
from base import views


project_slug = r'^projects/(?P<project_slug>[\w-]+)/'

urlpatterns = patterns('',
    url(r'^$', views.IndexView.as_view(), name='index'),
    url(r'^seeds/$', views.SeedsListView.as_view(), name='seeds_list'),
    url(r'^seeds/(?P<seeds_slug>[\w-]+)/$', views.EditSeedsView.as_view(), name='edit_seeds'),
    url(r'^about/$', views.AboutView.as_view(), name='about'),
    url(r'^add_project/$', views.AddProjectView.as_view(),
        name='add_project'),
    url(project_slug + r'$', views.ProjectView.as_view(),
        name='project'),
    url(project_slug + r'settings/$', views.ProjectSettingsView.as_view(),
        name='project_settings'),
    url(project_slug + r'tad/$', views.TadView.as_view(),
        name='tad'),
    url(project_slug + r'settings/delete/$', views.DeleteProjectView.as_view(),
        name='delete_project'),
    url(project_slug + r'add_dataset/$', views.AddIndexView.as_view(),
        name='add_index'),
    url(project_slug + r'datasets/$', views.ListIndicesView.as_view(),
        name='indices'),
    url(project_slug + r'datasets/(?P<index_slug>[\w-]+)/settings/$',
        views.IndexSettingsView.as_view(), name='index_settings'),
    url(project_slug + r'datasets/(?P<index_slug>[\w-]+)/settings/delete/$',
        views.DeleteIndexView.as_view(), name='delete_index'),
)


# The following lines build a url route to each application listed in
#   `settings.EXPLORER_APPS`, namespaced appropriately.
#   See <https://github.com/ContinuumIO/memex-explorer/issues/316>

from django.conf import settings

inject_urls = [
    url(project_slug, include('apps.%s.urls' % app, namespace=app))
    for app in settings.EXPLORER_APPS
]

urlpatterns += patterns('', *inject_urls)

source/apps/crawl_space/models.py
import os
import shutil

from os.path import join

from django.db import models
from django.utils.text import slugify
from django.core.urlresolvers import reverse
from django.core.exceptions import ValidationError, NON_FIELD_ERRORS
from django.core.files.base import ContentFile
from django.core.files.uploadedfile import SimpleUploadedFile

from base.models import Project, SeedsList, alphanumeric_validator
from apps.crawl_space.utils import ensure_exists

from apps.crawl_space.settings import (crawl_resources_dir, resources_dir,
    MODEL_PATH, CRAWL_PATH, SEEDS_TMP_DIR, MODELS_TMP_DIR)


def validate_model_file(value):
    if value != 'pageclassifier.model':
        raise ValidationError("Model file must be named 'pageclassifier.model'.")


def validate_features_file(value):
    if value != 'pageclassifier.features':
        raise ValidationError("Features file must be named 'pageclassifier.features'.")


def get_model_upload_path(instance, filename):
    """
    This method must stay outside of the class definition because django
    cannot serialize unbound methods in Python 2:

    https://docs.djangoproject.com/en/dev/topics/migrations/#migration-serializing
    """
    return os.path.join(MODEL_PATH, instance.name, filename)


class CrawlModel(models.Model):
    """CrawlModel model, specifically for ACHE crawls.

    Model Fields
    ------------

    name : str, 64 characters max
    model : FileField
        Upload pageclassifier.model file
    features : FileField
        Upload pageclassifier.features file
    project : fk to base.Project

    """

    def get_model_path(self):
        return join(MODEL_PATH, self.name)

    def ensure_model_path(self):
        model_path = self.get_model_path()
        ensure_exists(model_path)
        return model_path

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    model = models.FileField(upload_to=get_model_upload_path,
        validators=[validate_model_file])
    features = models.FileField(upload_to=get_model_upload_path,
        validators=[validate_features_file])
    project = models.ForeignKey(Project)

    def get_absolute_url(self):
        return reverse('base:project',
            kwargs=dict(project_slug=self.project.slug))

    def save(self, *args, **kwargs):
        if self.pk is None:
            self.slug = slugify(self.name)
            # TODO:
            # Another weird call with a side effect that has to be fixed.
            model_path = self.ensure_model_path()

        return super(CrawlModel, self).save(*args, **kwargs)

    @property
    def url(self):
        return self.get_absolute_url()

    def __unicode__(self):
        return self.name


def get_seeds_upload_path(instance, filename):
    """
    This method must stay outside of the class definition because django
    cannot serialize unbound methods in Python 2:

    https://docs.djangoproject.com/en/dev/topics/migrations/#migration-serializing
    """
    if instance.crawler == "nutch":
        seeds_list_path = os.path.join(CRAWL_PATH, instance.slug, "seeds", "seeds")
    elif instance.crawler == "ache":
        seeds_list_path = os.path.join(CRAWL_PATH, instance.slug, "seeds")
    return seeds_list_path


class Crawl(models.Model):
    """Crawl model.

    Model Fields
    ------------

    name : str, 64 characters max
    slug : str, 64 characters max
        The `slug` field is derived from `name` on save, and is restricted
        to URL-safe characters.
    description : str
    crawler : str
        Either 'nutch' or 'ache'
    status : str
    config : str
        [ACHE] Name of configuration directory, defaults to "config_default"
    seeds_list : FileField
        Upload text file containing seed URLs
    pages_crawled : int
    harvest_rate : float
        [ACHE] Ratio of relevant pages in the crawl
    project : fk to base.Project
    crawl_model : fk to CrawlModel
    """

    def get_crawl_path(self):
        return join(self.crawl_location)

    def get_config_path(self):
        return os.path.join(self.crawl_location, "config")

    def ensure_crawl_path(self):
        crawl_path = self.crawl_location
        ensure_exists(crawl_path)
        return crawl_path

    def get_default_config(self):
        return os.path.join(crawl_resources_dir, "configs", "config_default")

    def get_solr_url(self):
        return SOLR_URL

    CRAWLER_CHOICES = (
        ('nutch', "Nutch"),
        ('ache', "ACHE"))

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    description = models.TextField(blank=True)
    crawler = models.CharField(max_length=64, choices=CRAWLER_CHOICES)
    status = models.CharField(max_length=64, default="NOT STARTED")
    config = models.CharField(max_length=64, default="config_default")
    seeds_object = models.ForeignKey(SeedsList, on_delete=models.PROTECT)
    seeds_list = models.FileField(default=None, null=True, blank=True, upload_to=get_seeds_upload_path)
    pages_crawled = models.BigIntegerField(default=0)
    harvest_rate = models.FloatField(default=0)
    project = models.ForeignKey(Project)
    crawl_model = models.ForeignKey(CrawlModel, null=True, blank=True,
        default=None, on_delete=models.PROTECT)
    rounds_left = models.IntegerField(default=1, null=True, blank=True)

    def save(self, *args, **kwargs):
        if self.pk is None:
            self.slug = slugify(unicode(self.name))
            # TODO:
            # Fix this function and its weird side effect. Without this line the
            # save method wont work.
            crawl_path = self.ensure_crawl_path()
            # If the crawler is ache, copy the config. If config already exists,
            # delete it.
            if self.crawler == 'ache':
                if os.path.exists(self.get_config_path()):
                    shutil.rmtree(self.get_config_path())
                shutil.copytree(self.get_default_config(), self.get_config_path())
                self.config = self.get_config_path()
                self.seeds_list = SimpleUploadedFile("seeds", bytes(self.seeds_object.to_file_string()))
            elif self.crawler == "nutch":
                self.seeds_list = SimpleUploadedFile("seeds", bytes(self.seeds_object.to_file_string()))
        return super(Crawl, self).save(*args, **kwargs)

    # TODO:
    # This is redundant. URL property is better.
    def get_absolute_url(self):
        return reverse('base:crawl_space:crawl',
            kwargs=dict(project_slug=self.project.slug, crawl_slug=self.slug))

    @property
    def url(self):
        return self.get_absolute_url()

    @property
    def index_name(self):
        return "%s_%s_%s" % (self.slug, self.project.slug, self.crawler)

    @property
    def crawl_location(self):
        return os.path.join(resources_dir, "crawls", self.slug)

    def __unicode__(self):
        return self.name

source/base/models.py
"""Base models."""

import os
import subprocess
import shutil
import json

from django.db import models
from django.utils.text import slugify
from django.core.urlresolvers import reverse
from django.core.validators import RegexValidator
from django.core.urlresolvers import reverse
from django.db.models.signals import post_save

from jinja2 import Template
from jinja2.runtime import Context

from django.conf import settings


def alphanumeric_validator():
    return RegexValidator(r'^[a-zA-Z0-9-_ ]+$',
        'Only numbers, letters, underscores, dashes and spaces are allowed.')


def zipped_file_validator():
    return RegexValidator(r'.*\.(ZIP|zip)$',
        'Only compressed archive (.zip) files are allowed.')


class Project(models.Model):
    """Project model.

    Every application that plugs into Memex Explorer should have a
    foreign key relationship to a Project.

    Model Fields
    ------------

    name : str, 64 characters max
    slug : str, 64 characters max
        The `slug` field is derived from `name` on save, and is restricted
        to URL-safe characters.
    description : textfield

    """

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    description = models.TextField(blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(unicode(self.name))
        super(Project, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('base:project',
            kwargs=dict(project_slug=self.slug))

    @property
    def url(self):
        return self.get_absolute_url()

    def kibana_url(self):
        return '/{}/kibana/'.format(self.name)

    def __unicode__(self):
        return self.name


def get_zipped_data_path(instance, filename):
    """
    This method must stay outside of the class definition because django
    cannot serialize unbound methods in Python 2:

    https://docs.djangoproject.com/en/dev/topics/migrations/#migration-serializing
    """
    return os.path.join(settings.MEDIA_ROOT, "indices", instance.slug, "zipped_data", filename)


class Index(models.Model):
    """Index model.

    The index model keeps track of indices that are made and what files are
    contained within them.

    Model Fields
    ------------

    name : str, 64 characters max
    description : textfield
    uploaded_data : Django FileField
    data_dolder : textfield
    project : fk to base.Project

    """
    def get_dumped_data_path(instance):
        return os.path.join(
            settings.MEDIA_ROOT,
            "indices",
            instance.slug,
            "data"
        )

    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    uploaded_data = models.FileField(upload_to=get_zipped_data_path,
        validators=[zipped_file_validator()])
    data_folder = models.TextField(blank=True)
    project = models.ForeignKey(Project)
    status = models.CharField(max_length=64, default="")
    num_files = models.IntegerField(default=0)

    def save(self, *args, **kwargs):
        self.slug = slugify(unicode(self.name))
        self.data_folder = self.get_dumped_data_path()
        super(Index, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('base:project',
            kwargs=dict(project_slug=self.project.slug))

    @property
    def index_name(self):
        return "%s_%s_%s" % (self.slug, self.project.slug, "dataset")

    def __unicode__(self):
        return self.name


class SeedsList(models.Model):
    name = models.CharField(max_length=64, unique=True,
        validators=[alphanumeric_validator()])
    slug = models.SlugField(max_length=64, unique=True)
    seeds = models.TextField()

    def save(self, *args, **kwargs):
        self.slug = slugify(unicode(self.name))
        super(SeedsList, self).save(*args, **kwargs)

    def to_file_string(self):
        return "\n".join(json.loads(self.seeds))

    def get_absolute_url(self):
        return reverse('base:edit_seeds',
            kwargs=dict(seeds_slug=self.slug))

    @property
    def url(self):
        return self.get_absolute_url()

    @property
    def file_string(self):
        return self.to_file_string()

    def __unicode__(self):
        return self.name

source/base/templates/base/underscore_templates/crawls_underscore.html
<script type="text/template" id="crawlTableHeader">
  <h4 style="line-height:2em;">
    <i class="fa fa-search"> &nbsp; </i>Crawls
  </h4>
  <table class="table table-condensed table-gray table-bordered">
    <tbody id="crawlTable">
    <tr>
      <th>Crawl Name</th>
      <th>Crawler</th>
      <th>Pages Crawled</th>
      <th>Status</th>
      <th>Actions</th>
      <th></th>
    </tr>
  </tbody>
  </table>
</script>


<script type="text/template" id="crawlTableItem">
  <tr>
    <td><a href="<%= url %>"><%= name %></a></td>
    <td><%= crawler %></td>
    <td><%= pages_crawled %></td>
    <td><%= status %></td>
    <td>
      <a href="<%= url + 'settings/' %>">
        <i class="fa fa-pencil"></i>
      </a>
      <form style="display:inline" action="<%= url + 'settings/delete/' %>"
      method="post" onSubmit="return confirm('Are you sure you want to delete this crawl?')">
          {% csrf_token %}
      <a href="#"><button class="fa fa-trash no-style-btn" type="submit"></button></a
      </form>
      <a href="{{ kibana }}" target="_blank"><i class="fa fa-pie-chart"></i></a>
    </td>
    <td>
      <a class="btn btn-success btn-xs" href="<%= url %>">View</a>
    </td>
  </tr>
</script>


<script type="text/template" id="addCrawlTemplate">
  <form method="post" enctype="multipart/form-data" id="addCrawlForm">
    {% csrf_token %}
    <input type="hidden" id="id_crawl_project" name="project" value="{{ project.id }}">
    <fieldset>
      <div id="div_id_name" class="form-group">
        <label for="id_name" class="control-label requiredField">
  				Name<span class="asteriskField">*</span>
        </label>
        <div class="controls ">
          <input class="textinput textInput form-control" id="id_name" maxlength="64" name="name" type="text" />
          <span class="help-block">
            <strong id="error_id_name" hidden></strong>
          </span>
        </div>
      </div>
      <div id="div_id_description" class="form-group">
        <label for="id_description" class="control-label ">
  				Description
  			</label>
        <div class="controls ">
          <textarea class="textarea form-control" cols="40" id="id_description" name="description" rows="10"></textarea>
        </div>
      </div>
      <div id="div_id_seeds_object" class="form-group">
        <label for="id_seeds_object" class="control-label requiredField">
          Seeds List<span class="asteriskField">*</span>
  			</label>
        <button style="float:right;margin:2px;;font-size:12px;" type="button" class="btn btn-default btn-duo center link-button" data-toggle="modal" data-target="#newSeedsModal">Add Seeds</button>
        <div class="controls ">
          <select class="select form-control" id="id_seeds_object" name="seeds_object">
            <option value="" selected="selected">---------</option>
          </select>
          <span class="help-block">
            <strong id="error_id_seeds_object" hidden></strong>
          </span>
        </div>
      </div>
      <div id="div_id_crawler" class="form-group">
        <label for="id_crawler"  class="control-label  requiredField">
          Crawler<span class="asteriskField">*</span>
        </label>
        <div class="controls">
          <label class="radio-inline">
            <input type="radio" checked="checked" name="crawler" id="id_crawler_1" value="nutch" >Nutch
          </label>
          <label class="radio-inline">
            <input type="radio" name="crawler" id="id_crawler_2" value="ache" >ACHE
          </label>
          <span class="help-block">
            <strong id="error_id_crawler" hidden></strong>
          </span>
        </div>
      </div>
      <div id="div_id_rounds_left" class="form-group">
        <label for="id_rounds_left" class="control-label ">
  				Rounds
  			</label>
        <div class="controls ">
          <input class="numberinput form-control" id="id_rounds_left" name="rounds_left" type="number" value="1" />
          <span class="help-block">
            <strong id="error_id_rounds_left" hidden></strong>
          </span>
        </div>
      </div>
      <div id="div_id_crawl_model" class="form-group">
        <label for="id_crawl_model" class="control-label ">
  				Crawl model
  			</label>
        <button style="float:right;margin:2px;;font-size:12px;" type="button" class="btn btn-default btn-duo center link-button" data-toggle="modal" data-target="#crawlModelModal">Add Model</button>
        <div class="controls ">
          <select class="select form-control" id="id_crawl_model" name="crawl_model">
            <option value="" selected="selected">---------</option>
          </select>
          <span class="help-block">
            <strong id="error_id_crawl_model" hidden></strong>
          </span>
        </div>
      </div>
      <hr />
      <div class="form-actions">
        <div class="col-md-2">
            <input type="submit" name="submit" value="Create" class="btn btn-primary" id="submit-id-submit" />
        </div>

        <div class="col-md-2">
         <input type="button" name="cancel" value="Cancel" class="btn btn-primary link-button" id="cancelSubmit" data-dismiss="modal" href="#">
        </div>
     </div>
    </fieldset>
  </form>
</script>


<script type="text/template" id="emptyCrawlTable">
  <h4 style="line-height:2em;">
    <i class="fa fa-search"> &nbsp; </i>Crawls
  </h4>
  <p id="noCrawls">No Crawls Registered.</p>
</script>

source/base/templates/base/underscore_templates/underscore_templates.html
<script type="text/template" id="addProjectTemplate">
  <form id="addProjectForm" method="post">
      {% csrf_token %}
      <div id="div_id_name" class="form-group">
          <label for="id_name" class="control-label  requiredField">
  			Name<span class="asteriskField">*</span>
          </label>
          <div class="controls ">
              <input class="textinput textInput form-control" id="id_name" maxlength="64" name="name" type="text" />
          </div>
          <span class="help-block">
              <strong id="error_id_name" hidden></strong>
          </span>
      </div>
      <div id="div_id_description" class="form-group">
          <label for="id_description" class="control-label ">
  			Description
  		</label>
          <div class="controls ">
              <textarea class="textarea form-control" cols="40" id="id_description" name="description" rows="10"></textarea>
          </div>
      </div>
      <hr>
      <div class="form-actions row">
        <div class="col-md-2">
            <input type="submit" name="submit" value="Create" class="btn btn-primary" id="submit-id-submit" />
        </div>

        <div class="col-md-2">
         <input type="button" name="cancel" value="Cancel" class="btn btn-primary link-button" id="cancelSubmit" data-dismiss="modal" href="#">
        </div>
     </div>
  </form>
</script>


<script type="text/template" id="indexProjectItem">
    <div class="col-lg-3 col-md-4 project-tab">
        <div class="panel panel-project">
            <div class="panel-heading">
            <a href="<%= url %>" style="text-decoration:none;">
                <div class="row">
                    <div class="col-md-12 color-set">
                        <p><%= name %></p>
                    </div>
                    <!--div class="col-xs-9 text-right">
                        <i class="fa {{project.icon}} fa-3x"></i>
                    </div-->
                </div>
            </div>
                <div class="panel-footer">
                    <p><%= description %></p>

                    <span class="pull-right"><i class="fa fa-arrow-circle-right"></i></span>
                    <div class="clearfix"></div>
                </div>
            </a>
        </div>
    </div>
</script>


<script type="text/template" id="crawlFormModel">
    <option value="<%= id %>"><%= name %></option>
</script>


<script type="text/template" id="crawlModelTableHeader">
  <h4 style="line-height:2em;">
    <i class="fa fa-bar-chart"> &nbsp; </i>Crawl Models
  </h4>
  <table class="table table-condensed table-gray table-bordered">
    <tbody id="crawlModelTable">
      <tr>
        <th>Name</th>
        <th>Actions</th>
      </tr>
    </tbody>
  </table>
</script>


<script type="text/template" id="crawlModelTableItem">
  <tr>
    <td><%= name %></td>
    <td>
      <form id="delete_crawl_model_<%= id %>" action="" method="post">
        {% csrf_token %}
        <a href="#"><button class="fa fa-trash no-style-btn" type="submit"></button></a>
      </form>
    </td>
  </tr>
</script>


<script type="text/template" id="emptyCrawlModelTable">
  <h4 style="line-height:2em;">
    <i class="fa fa-bar-chart"> &nbsp; </i>Crawl Models
  </h4>
  <p id="noCrawlModels">No Crawl Models Registered.</p>
</script>


<script id="addCrawlModelTemplate" type="text/template">
<div hidden id="progress">
    <center><h4>Upload Progress</h4></center>
    <div class="progress">
        <div id="upload_progress" class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="min-width:2em;width:2%;">
            <div id="upload_percentage"></div>
        </div>
    </div>
</div>


<form id="addCrawlModelForm" method="post" enctype="multipart/form-data">
    {% csrf_token %}
    <input type="hidden" id="id_crawl_model_project" name="project" value="{{ project.id }}">
    <div id="div_id_name" class="form-group">
        <label for="id_name" class="control-label requiredField">
            Name<span class="asteriskField">*</span>
        </label>
        <div class="controls ">
            <input class="textinput textInput form-control" id="id_name" maxlength="64" name="name" type="text" />
            <span class="help-block">
                <strong id="error_id_name" hidden></strong>
            </span>
        </div>
    </div>
    <div id="div_id_model" class="form-group">
        <label for="id_model" class="control-label requiredField">
            Model<span class="asteriskField">*</span>
        </label>
        <div class="controls ">
            <input class="clearablefileinput" id="id_model" name="model" type="file" />
            <span class="help-block">
                <strong id="error_id_model" hidden></strong>
            </span>
        </div>
    </div>
    <div id="div_id_features" class="form-group">
        <label for="id_features" class="control-label  requiredField">
            Features<span class="asteriskField">*</span>
        </label>
        <div class="controls ">
            <input class="clearablefileinput" id="id_features" name="features" type="file" />
            <span class="help-block">
                <strong id="error_id_features" hidden></strong>
            </span>
        </div>
    </div>
    <div class="form-actions row">
        <div class="col-md-2">
            <input type="submit" name="submit" value="Create" class="btn btn-primary" id="submit-id-submit"/>
        </div>
        <div class="col-md-2">
            <input type="button" name="cancel" value="Cancel" class="btn btn-primary link-button" id="cancelSubmit" data-dismiss="modal" href="#">
        </div>
    </div>
</form>
</script>